Redmine - Defect #11098

Default priorities have the same position and can't be reordered
2012-06-06 02:27 - Stanislav German-Evtushenko

Status: Closed Start date:

Priority: High Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 2.0.3

Resolution: Fixed Affected version: 2.0.2
Description

CSS class "priority-N" doesn't depend on an issue priority anymore and it is always "priority-2". As a result - alnernate theme priority
colours don't work.

It worked well in 1.4-stable.

Associated revisions

Revision 9781 - 2012-06-09 09:27 - Jean-Philippe Lang

Priorities have the same position and can't be reordered (#11098).

History

#1 - 2012-06-06 09:56 - Etienne Massip

- Resolution set to Cant reproduce

Works fine on trunk and | don't think there has been some fix committed related to this issue.

#2 - 2012-06-06 10:03 - Stanislav German-Evtushenko

® please have a look: hitp:/redmine.ourproject.org/projects/kune/issues

<tr id="issue-284" class="hascontextmenu odd issue status-1 priority-2">
<td class="checkbox hide-when-print"><input name="ids[]" value="284" type="checkbox"></td>
<td class="id"><a href="/issues/284">284</a></td>
<td class="tracker">Bug</td><td class="status">New</td><td class="priority">High</td><td class="su
bject"><a href="/issues/284">Add time in errors</a></td><td class="assigned_to"><a href="/users/4">Vicente
J. Ruiz Jurado</a></td><td class="updated_on">06/05/2012 03:07 am</td>

</tr>
<tr id="issue-283" class="hascontextmenu even issue status-1 priority-2">
<td class="checkbox hide-when-print"><input name="ids[]" value="283" type="checkbox"></td>

<td class="id"><a href="/issues/283">283</a></td>
<td class="tracker">Bug</td><td class="status">New</td><td class="priority">High</td><td class="su
bject"><a href="/issues/283">Create custom "More" menu in Kune</a></td><td class="assigned_to"><a href="/u
sers/4">Vicente J. Ruiz Jurado</a></td><td class="updated_on">06/05/2012 02:05 am</td>
</tr>
<tr id="issue-282" class="hascontextmenu odd issue status-1 priority-2">
<td class="checkbox hide-when-print"><input name="ids[]" value="282" type="checkbox"></td>
<td class="id"><a href="/issues/282">282</a></td>
<td class="tracker">Bug</td><td class="status">New</td><td class="priority">Normal</td><td class="
subject"><a href="/issues/282">The unread notification in the header does not get updated automatically so
metimes</a></td><td class="assigned_to"><a href="/users/4">Vicente J. Ruiz Jurado</a></td><td class="updat
ed_on">06/04/2012 12:08 am</td>

</tr>
<tr id="issue-281" class="hascontextmenu even issue status-1 priority-2">
<td class="checkbox hide-when-print"><input name="ids[]" value="281" type="checkbox"></td>

<td class="id"><a href="/issues/281">281</a></td>
<td class="tracker">Bug</td><td class="status">New</td><td class="priority">High</td><td class="su
bject"><a href="/issues/281">Cannot load waves, frequently (video)</a></td><td class="assigned_to"><a href
="/users/4">Vicente J. Ruiz Jurado</a></td><td class="updated_on">06/02/2012 07:21 pm</td>
</tr>
#3 - 2012-06-06 10:09 - Stanislav German-Evtushenko

¢ From Administration -> Information page:
Information

Redmine 2.0.2.stable.9774

Default administrator account changed True

Attachments directory writable True

Plugin assets directory writable True

RMagick available (optional) True

Environment:
Redmine version 2.0.2.stable. 9774
Ruby version 1.9.3 (i686-1linux)
Rails version BINOINS
Environment production
Database adapter SQLite

Redmine plugins:
no plugin installed

#4 - 2012-06-06 10:35 - Etienne Massip
Indeed.

Did you make some manual changes to Issue#css_classes (source:/tags/2.0.2/app/models/issue.rb#L 682)?
What's your enumerations table contents looks like?
#5 - 2012-06-06 10:38 - Etienne Massip

- Affected version (unused) changed from 2.0.1 to 2.0.2
- Affected version changed from 2.0.1 to 2.0.2

#6 - 2012-06-06 10:44 - Stanislav German-Evtushenko

Nothing were changed at all. Enumerations also were not changed. Screenshot is attached.

#7 - 2012-06-06 10:45 - Stanislav German-Evtushenko

- File enumeration.png added

#8 - 2012-06-06 11:42 - Etienne Massip

Sorry, no clue.

Could you please post the database enumerations table contents?
#9 - 2012-06-06 11:47 - Stanislav German-Evtushenko
Sorry, | don't have an access to the database currently but | made the same test with a clean database that was just migrated and data default was

loaded - same result.

#10 - 2012-06-06 21:19 - Stanislav German-Evtushenko
- File production.sqlite3 added

database example is attached

#11 - 2012-06-08 01:03 - Etienne Massip

- File enumerations.png added

There is something wrong with your enumerations table contents:
TABLE enumerations [Recﬂerche ] [ Tout voir ] [ﬂjouter une nouvelle Entréel l Duplicate I légiterles entré

id name position is_default type active
1 |User documentation |l |D0cumentCategur}r
2 |Technica| documen... |2 |DncumentCategnry
3 Low IssuePriority
4 Mormal IssuePriority
5 High IssuePriority
6 Urgent IssuePriority
7 suePriority
g |Design |TimEEntr}rActivity
5 |Deve|0pmer1t |TimeEntr}rActivity
Every IssuePriority except Low has a position of 2.
#12 - 2012-06-08 06:26 - Stanislav German-Evtushenko
Etienne Massip wrote:
There is something wrong with your enumerations table contents:
TABLE enumerations [ Recherche ] [ Tout voir ] l Ajouter une nouvelle entrée l l Duplicate l l Editer les entré
id name position is_default type active
1 |User documentation |1 |f |DocumentCategnr}r |t
2 |Technica| documen... |2 |f |D0cumentCategur}r |t
3 Low IssuePriority
4 Mormal IssuePriority
3 High IssuePriority
L Urgent IssuePriority
7 IssuePriority
8 | Design 1 ¢ |TimeEntryActivity |t
9 |De~.relnpment |2 |f |Til"ﬂEEr1tr}fACti".fit}f |t

Every IssuePriority except Low has a position of 2.

That clear database just migrated and English default data loaded. Can it be database migation or sqlite3 problem?
So, as a workaround | can try fix database manually, right?

#13 - 2012-06-08 08:47 - Stanislav German-Evtushenko

I have just tried to change position using admin interface - doesn't work. I'm not sure why but only 1 and 2 are possible. If | click "Move down" again it
does nothing.

#14 - 2012-06-08 14:59 - Etienne Massip

- Status changed from New to Confirmed

- Priority changed from Normal to High

- Target version set to Candidate for next minor release

- Resolution deleted (Cant reproduce)
You're just right, just reproduced it very easily with a simple db:migrate redmine:load_default_data sequence.
#15 - 2012-06-08 16:56 - Etienne Massip

Looks like the default_scope defined in rce: 2.0.2 models/enumeration.rb#L21 overrides the condition in
source:/tags/2.0.2/lib/plugins/acts_as_list/lib/active_record/acts/list.rb#L.212.

#16 - 2012-06-08 19:24 - Etienne Massip
There's an open Rails issue about this behavior.

What | don't get is that it used to work but still | can reproduce even with 1.4 branch???
Here's a simple patch to fix it:

Index: lib/plugins/acts_as_list/lib/active_record/acts/list.rb

-—— lib/plugins/acts_as_list/lib/active_record/acts/list.rb (revision 9776)
+++ lib/plugins/acts_as_list/lib/active_record/acts/list.rb (working copy)
@@ -209,7 +209,7 @@

def bottom_item(except = nil)
conditions = scope_condition
conditions = "#{conditions} AND #{self.class.primary_key} != #{except.id}" 1if except
= acts_as_list_class.find(:first, :conditions => conditions, :order => "#{position_column} DESC")
+ acts_as_list_class.where(conditions) .reorder ("#{position_column} DESC").first
end

# Forces item to assume the bottom position in the list.
Last thought: specifying the value of the position field in loader is useless since it will be set by acts_as_list in the end.

#17 - 2012-06-08 19:24 - Etienne Massip

- Target version changed from Candidate for next minor release to 2.0.3

Worth it (1.4.47).

#18 - 2012-06-08 20:01 - Stanislav German-Evtushenko

Etienne, same for me. When | first installed Redmine 1.4.1 (and we've been still using it) there was no such problem. Then we upgraded to 1.4.2 and
it still works well.

#19 - 2012-06-08 21:03 - Jean-Philippe Lang

It seems to affect 2.0.x only. Data loading works fine with 1.4.x for me.
#20 - 2012-06-08 21:16 - Etienne Massip
Jean-Philippe Lang wrote:
It seems to affect 2.0.x only. Data loading works fine with 1.4.x for me.
I ran the IssuePriority.create! in rails console and saw that the statement was the same as in 2.x with the two sorting specifications in the same wrong
order.
Maybe is there some final override if you specify the :position column value in Rails 2.3.
Or, more probably, | missed something.
Edit: | confirm it worked on 1.4

#21 - 2012-06-08 23:59 - Jean-Philippe Lang

- Subject changed from priority-N for CSS doesn't work to Default priorities have the same position and can't be reordered

#22 - 2012-06-09 09:32 - Jean-Philippe Lang
- Status changed from Confirmed to Resolved
- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Fixed in r9781. Priorities are now created correctly. For existing priorities with the same position, you can now reorder them properly (they will be
automatically fixed and updated to sequential numbers the first time you move one priority in the list).

#23 - 2012-06-09 15:58 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Merged.

Files

enumeration.png 71.8 KB 2012-06-06 Stanislav German-Evtushenko
production.sqlite3 214 KB 2012-06-06 Stanislav German-Evtushenko
enumerations.png 18.6 KB 2012-06-07 Etienne Massip
